%define  ENABLE_ANSI  1

%define  gcl_cc       gcc

%define  LOCBFD	      0

%define  maxpage      512*1024

%define  vssize	       64*1024
%define  bdssize        4*1024
%define  ihssize        8*1024
%define  frssize        8*1024

%define	 CVS_BUILD  0	

Name: gcl
Version: 2.6.8
Release: alt0.09cvs20061026
Summary: GNU Common Lisp
Copyright: LGPL
Group: Development/Lisp
URL: http://savannah.gnu.org/projects/gcl
Packager: Vadim V. Zhytnikov <vvzhy@altlinux.ru>

Source0: gcl-%version.tar.gz

Patch1: gcl-%version-ansi-both.patch
Patch2: gcl-%version-makefile.patch 

Requires: tk tcl libreadline libncurses

PreReq: %__install_info

BuildRequires: libreadline-devel libncurses-devel tcl-devel tk-devel libiberty-devel libbfd-devel-static tetex texinfo

%description
The program GCL is an implementation of a subset of 
the Common Lisp ANSI standard.  It is written in C and 
in Common Lisp, and is highly portable.  It includes 
those features in the original definition of Common Lisp,
(Guy Steele version 1.), as well as some features from 
the new standard.

%if %ENABLE_ANSI 
This package is shipped with two GCL flavors.  First is
the traditional CLtL1 compliant GCL.  Second is experimental
ANSI Common Lisp compliant GCL version.  ANSI GCL is invoked 
if GCL_ANSI is set to "yes".
%endif

%description -l ru_RU.UTF-8
GCL - это реализация языка Common Lisp, описанного 
в стандарте ANSI.  GCL написан C и Common Lisp и обладает 
высокой степенью переносимости.  GCL состветствует описанию 
языка Common Lisp, опубликованному в книге "Common Lisp
the Language", Guy Steele, первое издание (CLtL1), и включает 
некоторые расширения из стандарта ANSI.

%if %ENABLE_ANSI 
Этот пакет включат в себя два типа GCL.  
Первый, т.н. традиционный вариант, соответствующий CLtL1.
И второй, экспериментальный вариант, соответствующий
стандарту ANSI.  По умолчанию вызывается традиционный
вариант, для вызова ANSI GCL необходимо установить
значение переменной окружения GCL_ANSI="yes".
%endif

%prep
%if %CVS_BUILD
%setup -q -b 0 -ngcl
%else
%setup -q -b 0  
%endif

%if %ENABLE_ANSI 
%patch1 -p1
%endif

%patch2 -p1


%build

PROCESSOR_FLAGS=`echo "%optflags" | %__sed -e "s:%optflags_default::"`
export PROCESSOR_FLAGS

CC=%gcl_cc ; export CC ; %configure \
    --enable-tkconfig=%_libdir      \
    --enable-tclconfig=%_libdir     \
%if %ENABLE_ANSI 
    --enable-ansi  \
%else
    --disable-ansi \
%endif 
%if %LOCBFD
    --disable-statsysbfd --enable-locbfd \
%endif
    --enable-maxpage=%maxpage \
    --enable-vssize=%vssize   \
    --enable-bdssize=%bdssize \
    --enable-ihssize=%ihssize \
    --enable-frssize=%frssize \
    --enable-infodir=%_infodir

make

%install
%define _findreq_default_method lib

install -d %buildroot%_infodir
install -d %buildroot%_man1dir
#install -d %buildroot%_datadir/emacs/site-lisp/gcl
install -d %buildroot%_includedir

make install DESTDIR=%buildroot \
    LIBARCH=%_lib \
    EMACS_SITE_LISP=%_datadir/emacs/site-lisp/gcl \
    EMACS_DEFAULT_EL=%_datadir/emacs/site-lisp/default.el
    
install -D -m644 ./elisp/*.el %buildroot%_datadir/emacs/site-lisp/gcl
install -D -m644 ./man/man1/gcl.1 %buildroot%_man1dir/gcl.1
%if %ENABLE_ANSI 
install -D -m755 ./unixport/saved_gcl %buildroot%_libdir/%name-%version/unixport/saved_gcl
install -D -m644 ./unixport/init_gcl.lsp %buildroot%_libdir/%name-%version/unixport/init_gcl.lsp
install -D -m644 ./unixport/libgcl.a %buildroot%_libdir/%name-%version/unixport/libgcl.a
%endif

ln -f -s %_libdir/%name-%version/h/cmpinclude.h %buildroot%_includedir/cmpinclude.h	     

%__subst "s:%buildroot/usr:/usr:g" %buildroot%_bindir/gcl   

%__subst "s:%buildroot/usr:/usr:g" %buildroot%_libdir/%name-%version/gcl-tk/demos/index.lsp

chmod 755 %buildroot%_bindir/gcl
chmod 644 %buildroot%_libdir/%name-%version/cmpnew/*
chmod 644 %buildroot%_libdir/%name-%version/lsp/*
chmod 644 %buildroot%_libdir/%name-%version/h/*
chmod 644 %buildroot%_libdir/%name-%version/gcl-tk/*
chmod 755 %buildroot%_libdir/%name-%version/gcl-tk/demos
chmod 755 %buildroot%_libdir/%name-%version/gcl-tk/gcltkaux
chmod 755 %buildroot%_libdir/%name-%version/gcl-tk/gcltksrv
chmod 644 %buildroot%_libdir/%name-%version/gcl-tk/demos/*
chmod 644 %buildroot%_libdir/%name-%version/unixport/*
chmod 755 %buildroot%_libdir/%name-%version/unixport/save*
chmod 644 readme* RELEASE* COPYING.LIB-2.0

%files
%defattr(-,root,root)
%_bindir/gcl
%_datadir/emacs/site-lisp/gcl
%dir %_libdir/%name-%version
%_libdir/%name-%version/cmpnew
%_libdir/%name-%version/gcl-tk
%_libdir/%name-%version/lsp
%_libdir/%name-%version/h
%_libdir/%name-%version/unixport
%_libdir/%name-%version/xgcl-2
%exclude %_libdir/%name-%version/pcl
%exclude %_libdir/%name-%version/clcs
%exclude %_libdir/%name-%version/info
%exclude %_datadir/emacs
%_includedir/cmpinclude.h
%_infodir/gcl*
%exclude %_infodir/dir
%exclude %_docdir/gcl-tk.*
%exclude %_docdir/gcl-tk/*
%exclude %_docdir/gcl-si.*
%exclude %_docdir/gcl-si/*
%exclude %_docdir/dw*
%_mandir/man1/gcl.1*
%doc readme* RELEASE* COPYING.LIB-2.0

%post
%install_info gcl-si.info gcl-tk.info 

%preun
%uninstall_info gcl-si.info gcl-tk.info 

%changelog
* Thu Oct 26 2006 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.8-alt0.09cvs20061026
- GCL 2.6.8pre cvs 26 Oct 2006.
- fixed compiler temp dir bug.

* Mon Oct 09 2006 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.8-alt0.08cvs20061008
- GCL 2.6.8pre cvs 08 Oct 2006.

* Sun Jan 08 2006 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.7-alt5
- Configure bug revealed by bash 3.1.1 fixed.

* Sat Dec 24 2005 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.7-alt4
- Backport of comile-tmp-dir patch from 2.6.8pre.

* Sat Oct 22 2005 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.7-alt3
- x86_64 build.

* Wed Aug 31 2005 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.7-alt2
- makefile (make install) fix.

* Fri Aug 12 2005 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.7-alt1
- GCL 2.6.7.

* Sat Jun 04 2005 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.6-alt3
- Work around make bug # 6777. 

* Sat Feb 19 2005 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.6-alt2
- Rebuild with gcc 3.4.

* Thu Jan 20 2005 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.6-alt1
- GCL 2.6.6.

* Fri Jan 14 2005 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.6-alt0.01
- GCL 2.6.6 rc cvs 2005.01.14.

* Mon Dec 13 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.5-alt4
- Make use %__subst.

* Mon Dec 06 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.5-alt3
- Fix some permissions.

* Wed Nov 03 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.5-alt2
- Building with locbfd due to new binutils incompatibility.

* Wed Aug 18 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.5-alt1
- GCL 2.6.5.

* Wed Jul 21 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.3-alt1
- GCL 2.6.3 bugfix release.

* Sat Jun 26 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.2-alt1
- GCL 2.6.2.

* Mon Jun 07 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.2-alt0.02
- GCL 2.6.2c2.

* Wed Jun 02 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.2-alt0.01
- GCL 2.6.2 release candidate.

* Sun May 09 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.1-alt0.06
- Rebuld with glibc 2.3.X.

* Mon Apr 05 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.1-alt0.05
- GC and allocation optimization.

* Wed Mar 03 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.1-alt0.04
- binutils fix reworked.

* Sat Feb 28 2004 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.1-alt0.03
- gcl 2.6.2 pre release.
- fixed problem with binutils 2.14.90.0.8. 

* Mon Sep 15 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.1-alt0.02
- configure recreation by autoconf is no longer required

* Fri Sep 12 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.6.1-alt0.01
- gcl 2.6.1 beta

* Thu Sep 04 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt8
- now package includes two images - tarditional CLtL1 gcl (invoked
  by default) and experimental ANSI CL gcl (invoked if GCL_ANSI is
  set to "yes"

* Tue Aug 26 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt7
- fix configure to respect -march
- patch to define all stacks size by configure
- enlarged stacks size

* Tue Aug 19 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt6
- spec fix

* Sun Aug 17 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt5
- set --build and --home as %_target_platform
- gcl %_libdir/gcl-%version added to the package

* Wed Jul 30 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt4
- set --buld and --home for proper arch subconfigure for gmp

* Sat Jul 12 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt3
- in configure --infodir replaced by --enable-infodir 
- gcl-tk patch

* Sun Jul 06 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt2
- fixed tkconfig and tclconfig

* Thu Jun 05 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.3-alt1
- gcl 2.5.3 bugfix release

* Fri Mar 21 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.2-alt1
- gcl 2.5.2 bugfix release

* Wed Mar 19 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.1-alt2
- fixed BuildRequires 

* Tue Mar 18 2003 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.1-alt1
- gcl 2.5.1 release

* Fri Oct 04 2002 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.0-alt0.03
- gcl CVS 04.10.2002

* Sun Sep 29 2002 Vadim V. Zhytnikov <vvzhy@altlinux.ru> 2.5.0-alt0.02
- gcl CVS 28.09.2002
- gcc 3.2 

* Mon Jul 15 2002 Vadim V. Zhytnikov <vvzhy@mail.ru> 2.5.0-alt0.01
- Initial ALT Linux release.
